
COMMENT $
*************************************************************************
*                                                                       *
*       File:           MESG.AH                                         *
*       Purpose:        Contains the public structs and definitions     *
*                       to interface to the message system              *
*       Copyright:      CopyRight (c) 1995 by Apple Computer, Inc.      *
*                               All rights reserved.                    *
*                                                                       *
*************************************************************************

#	Change History (most recent first):
#
#
COMMEND $

;-----------------------------------------------------------------------------
;                               Message Data Types
;-----------------------------------------------------------------------------

MsgPBlk         STRUCT
link                    DWORD   ?       ; Link to next Queue element
msgCmd                  WORD    ?       ; The message command or type
msgParam1               DWORD   ?       ; Param 1
msgParam2               DWORD   ?       ; Param 2
msgCompletion           DWORD   ?       ; Ptr to the completion routine
msgBuffer               DWORD   ?       ; Ptr to the data buffer
msgReqCount             DWORD   ?       ; Length of the data
msgActCount             DWORD   ?       ; # of bytes actually transfered
msgResult               BYTE    ?       ; The error code after complete or 1
msgFlags                BYTE    ?
msgUserData             DWORD   ?       ; for caller's use
msgVXD                  DWORD   ?       ; Used by VxD
MsgPBlk         ENDS

MsgRecElem      STRUCT
Link                    DWORD   ?       ; Ptr to next link
Code                    DWORD   ?       ; Ptr to the Code for this link
cmdBase                 WORD    ?       ; the base message number for this proc
cmdCount                WORD    ?       ; the # of message numbers for this proc
userData                DWORD   ?       ; for caller's use
recVXD                  DWORD   ?       ; Used by VxD
MsgRecElem      ENDS

AckInfo			STRUCT
bytesReceived			DWORD	?		; Number of bytes recevied by the Mac.
ackReceived				BYTE	?		; Was the ack sent?
AckInfo			ENDS

;-----------------------------------------------------------------------------
;                       PC Message system Interface  
;-----------------------------------------------------------------------------
MsgCall                 equ     05Fh    ; Interrupt for Message Interface

rsIsAvailable           equ     00      ; Index for is available
rsSendMessage           equ     01      ; Index for Send func
rsInstallMsgHandler     equ     02      ; Index for Install Msg Handler func
rsRemoveMsgHandler      equ     03      ; Index for Remove Msg Handler func
rsRegisterMessage       equ     04      ; Index for Register Msg
rsVersionCheck          equ     05      ; Index to get the version numbers

CR	EQU	0Dh
LF	EQU	0Ah
ESCAPE	EQU	1Bh
